function  varargout=plotIsolines(self,u,varargin)
  % plotoptions={'Color','w','LineWidth',2}
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('niso',10,@isscalar);
  %p.addParamValue('colormap','',@ischar);
  %p.addParamValue('colorbar',false,@islogical); % FC [04/01/2016] supprime-> appel externe
  p.addParamValue('color',[]); % unique color
  p.addParamValue('plan',false,@islogical);
  %p.addParamValue('PlotOptions',{},@iscell);
  p.addParamValue('isorange',[]);
  p.parse(varargin{:});
  R=p.Results;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  assert(  (self.d==2) && ismember(self.dim,[2,3]) )
  if (isempty(R.isorange) && R.niso>1), R.isorange=linspace(min(u),max(u),R.niso);end
  R.niso=length(R.isorange); 
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else  
    assert(length(u)==self.nq);
    U=u;
  end
  if size(U,1)==1, U=U';end
  [LS,LD,I] = fc_tools.graphics.gptoolbox.isolines(self.q',self.me',U,R.isorange);
%    if isempty(R.colormap)
%      colors = selectColors(R.niso);
%    else

  if isempty(R.color)
    cmap=colormap();%R.colormap);
    t=0:1/(R.niso-1):1;
    colors = RGB(t,cmap);
  else
    if size(R.color,1)==1
      if ischar(R.color), R.color = colorstr2rgb(R.color);end
      colors=ones(R.niso,1)*R.color;
    else
      assert( (size(R.color,1)==R.niso) && (size(R.color,2)==3) )
      colors=R.color;
    end
  end
  
  PrevHold=fc_tools.graphics.SetHoldOn(true);
  if fc_tools.comp.isOctave() % Add for testing but line/plot commands are very slowwwww under Octave
    fprintf('[fc-simesh] plotIsolines function very slow under Octave\n');
  end
  for i=1:R.niso
    II=find(I==i);
    % Correctif Bug d'affichage avec plot => plot3
%plotval & plotisolines() a tester sur 2015a - ce qui suit est une
%alternative
    % FC [04/01/2016] : modif pour fonctionnner avec trisurf en 2d
    % FC [30/06/2016] : ajout option plan
%        X=[LS(II,1) LD(II,1)]';Y=[LS(II,2) LD(II,2)]';
%        h=5;
%        S=sqrt((X(1,:)-X(2,:)).^2+(Y(1,:)-Y(2,:)).^2);J=find(S>h/10^2);
%        fprintf('i=%d , numel(II)=%d, numel(J)=%d\n',i,numel(II),numel(J)); 
%        if numel(J)>0
%        X=X(:,J);Y=Y(:,J);
%        hd=plot(X,Y,'color',colors(i,:),varargin{:});
%      end  
%    else
    if self.dim==2
      %hd=plot3([LS(II,1) LD(II,1)]',[LS(II,2) LD(II,2)]',1e-1*ones(2,size(II,1)),'Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),R.PlotOptions{:});
      if R.plan
        hd=plot([LS(II,1) LD(II,1)]',[LS(II,2) LD(II,2)]','Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),varargin{:});
      else
        hd=plot3([LS(II,1) LD(II,1)]',[LS(II,2) LD(II,2)]',R.isorange(i)*ones(2,size(II,1)),'Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),varargin{:});
      end
    else
      hd=plot3([LS(II,1) LD(II,1)]',[LS(II,2) LD(II,2)]',[LS(II,3) LD(II,3)]','Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),varargin{:});
    end
%    end
    
  end
%    if R.colorbar
%      if isOctave()
%        caxis([R.isorange(1), R.isorange(end)])
%        colorbar
%      else
%        colorbarIso(colors,R.isorange)
%      end
%    end
  if nargout>=1, varargout{1}=colors;end
  if nargout==2, varargout{2}=R.isorange;end
  fc_tools.graphics.RestoreHold(PrevHold)
end
